package com.bkm.mobil.bex_flutter_plugin

import android.app.Activity
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

class BexFlutterPlugin : MethodCallHandler {

    companion object {
        var context: Activity? = null
        var callbackChannel: MethodChannel? = null

        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val channel = MethodChannel(registrar.messenger(), "bex_flutter_plugin")
            callbackChannel = MethodChannel(registrar.messenger(), "bex_flutter_plugin/callback")
            channel.setMethodCallHandler(BexFlutterPlugin())
            context = registrar.activity()
        }

        const val SET_DEBUG_MODE = "setDebugMode"
        const val SUBMIT_CONSUMER = "submitConsumer"
        const val RESUBMIT_CONSUMER = "resubmitConsumer"
        const val PAYMENT = "payment"
    }

    override fun onMethodCall(call: MethodCall, result: Result) {
        when (call.method) {
            SET_DEBUG_MODE -> {
                BexSdk.isDebugMode = call.argument<Boolean>("isDebugMode") ?: false
            }
            SUBMIT_CONSUMER -> {
                BexSdk.submitConsumer(call.argument<String>("token"))
            }
            RESUBMIT_CONSUMER -> {
                BexSdk.resubmitConsumer(call.argument<String>("ticket"))
            }
            PAYMENT -> {
                BexSdk.payment(call.argument<String>("token"))
            }
            else -> {
                result.notImplemented()
            }
        }
    }
}
